VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin
'mWndProcOrg holds the original address of the
'Window Procedure for this window. This is used to
'route messages to the original procedure after you
'process them.
Private mWndProcOrg As Long

'Handle (hWnd) of the subclassed window.
Private mHWndSubClassed As Long

'Constant for Windows Message used in sample.
Private Const WM_MOUSEACTIVATE = &H21

'This plugins form
Private m_oForm As console.frmMain

'The name of this instance
Private m_sName As String
Private Function IBasePlugin_StartPlugin(Name As String) As Long
    
    Dim ctop As Long
    Dim cbottom As Long
    Dim cright As Long
    Dim cleft As Long
    
    m_sName = Name
    Set m_oForm = New console.frmMain
    Call Load(m_oForm)
    
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang Name, "!log"
    oServer.RegisterBang Name, "!hide"
    oServer.RegisterBang Name, "!show"
    oServer.RegisterBang Name, "!toggle"
    
'    ctop = oServer.evalNum(oServer.GetKey("window", "top"))
'    cbottom = oServer.evalNum(oServer.GetKey("window", "bottom"))
'    cleft = oServer.evalNum(oServer.GetKey("window", "left"))
'    cright = oServer.evalNum(oServer.GetKey("window", "right"))
    
    m_oForm.left = oServer.evalNum(oServer.GetKey(m_sName, "x")) * Screen.TwipsPerPixelX
    m_oForm.top = oServer.evalNum(oServer.GetKey(m_sName, "y")) * Screen.TwipsPerPixelY
    m_oForm.Width = oServer.evalNum(oServer.GetKey(m_sName, "width")) * Screen.TwipsPerPixelX
    m_oForm.Height = oServer.evalNum(oServer.GetKey(m_sName, "height")) * Screen.TwipsPerPixelY
'    m_oForm.Picture = LoadPicture(oServer.GetKey("window", "background"))
    
'    m_oForm.lstConsole.top = ctop
'    m_oForm.lstConsole.left = cleft
'    m_oForm.lstConsole.Width = m_oForm.ScaleWidth - (cleft + cright)
'    m_oForm.lstConsole.Height = m_oForm.ScaleHeight - m_oForm.txtCommand.Height - (ctop + cbottom)
    
'    m_oForm.txtCommand.top = ctop + m_oForm.lstConsole.Height
'    m_oForm.txtCommand.left = cleft
'    m_oForm.txtCommand.Width = m_oForm.ScaleWidth - (cleft + cright)

    oServer.skin m_oForm.hwnd
    m_oForm.Tag = Name
    Call m_oForm.Show
    SubClass
    IBasePlugin_StartPlugin = m_oForm.hwnd

End Function
Private Sub IBasePlugin_StopPlugin()
    
    UnSubClass
    Call m_oForm.Hide
    Call Unload(m_oForm)
    Set m_oForm = Nothing

End Sub
Private Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)

    Dim timeformat As String
    
    Select Case Name
    Case "!log"
        timeformat = oServer.GetKey(m_sName, "timeformat")
        If timeformat <> "" Then
            Arguments = Format(Now, timeformat) & " : " & Arguments
        End If
        If oServer.evalBool(oServer.GetKey(m_sName, "WriteToEventLog")) Then
            App.LogEvent Arguments, vbLogEventTypeInformation
        End If
        m_oForm.lstConsole.AddItem Arguments
        m_oForm.lstConsole.ListIndex = m_oForm.lstConsole.ListCount - 1
    Case "!hide"
        If LCase(Arguments) = LCase(m_sName) Then
            m_oForm.Visible = False
        End If
    Case "!show"
        If LCase(Arguments) = LCase(m_sName) Then
            m_oForm.Visible = True
        End If
    Case "!toggle"
        If LCase(Arguments) = LCase(m_sName) Then
            m_oForm.Visible = Not m_oForm.Visible
        End If
    End Select
   
End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
Private Sub SubClass()
   '-------------------------------------------------------------
   'Initiates the subclassing of this UserControl's window (hwnd).
   'Records the original WinProc of the window in mWndProcOrg.
   'Places a pointer to the object in the window's UserData area.
   '-------------------------------------------------------------

   'Exit if the window is already subclassed.
   If mWndProcOrg Then Exit Sub

      'Redirect the window's messages from this control's default
      'Window Procedure to the SubWndProc function in your .BAS
      'module and record the address of the previous Window
      'Procedure for this window in mWndProcOrg.
      mWndProcOrg = SetWindowLong(m_oForm.hwnd, GWL_WNDPROC, AddressOf SubWndProc)

      'Record your window handle in case SetWindowLong gave you a
      'new one. You will need this handle so that you can unsubclass.
      mHWndSubClassed = m_oForm.hwnd

      'Store a pointer to this object in the UserData section of
      'this window that will be used later to get the pointer to
      'the control based on the handle (hwnd) of the window getting
      'the message.
      Call SetWindowLong(m_oForm.hwnd, GWL_USERDATA, ObjPtr(Me))

End Sub
Private Sub UnSubClass()
   
   '-----------------------------------------------------------
   'Unsubclasses this UserControl's window (hwnd), setting the
   'address of the Windows Procedure back to the address it was
   'at before it was subclassed.
   '-----------------------------------------------------------

   'Ensures that you don't try to unsubclass the window when
   'it is not subclassed.
   If mWndProcOrg = 0 Then Exit Sub

   'Reset the window's function back to the original address.
   SetWindowLong mHWndSubClassed, GWL_WNDPROC, mWndProcOrg
   '0 Indicates that you are no longer subclassed.
   mWndProcOrg = 0

End Sub
Friend Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   '--------------------------------------------------------------
   'Process the window's messages that are sent to this plugin.
   'The WindowProc function is declared as a "Friend" function so
   'that the .BAS module can call the function but the function
   'cannot be seen from outside the plugin project.
   '--------------------------------------------------------------

    Dim IsLEFT As Boolean
    Dim IsRIGHT As Boolean
    Dim IsTOP As Boolean
    Dim IsBOTTOM As Boolean
    Dim retVal As Long     'Where on the form is the mouse?
    Dim Mouse_X As Long    'Mouse coordinates
    Dim Mouse_Y As Long
    Dim r As RECT

    'Forwards the window's messages that came in to the original
    'Window Procedure that handles the messages and returns
    'the part of the form the mouse is on.
    retVal = CallWindowProc(mWndProcOrg, m_oForm.hwnd, uMsg, wParam, ByVal lParam)
    
    'What message received?
    Select Case uMsg
        Case WM_NCHITTEST      'Every mouse action
            'We will now handle movement and resizing of the form.
            
            'Get the location of the mouse
            Mouse_X = LoWord(lParam)
            Mouse_Y = HiWord(lParam)
            
            'Get the size of the window
            GetWindowRect hwnd, r
            
            If retVal = HTCLIENT Then  'action on client area
                
                IsRIGHT = (Mouse_X = r.right - 1) Or (Mouse_X = r.right - 2)
                IsLEFT = (Mouse_X = r.left + 1) Or (Mouse_X = r.left + 2)
                IsTOP = (Mouse_Y = r.top + 1) Or (Mouse_Y = r.top + 2)
                IsBOTTOM = (Mouse_Y = r.bottom - 1) Or (Mouse_Y = r.bottom - 2)
                
                If IsTOP Then
                    If IsRIGHT Then
                        retVal = HTTOPRIGHT
                    ElseIf IsLEFT Then
                        retVal = HTTOPLEFT
                    Else
                        retVal = HTTOP
                    End If
                ElseIf IsBOTTOM Then
                    If IsRIGHT Then
                        retVal = HTBOTTOMRIGHT
                    ElseIf IsLEFT Then
                        retVal = HTBOTTOMLEFT
                    Else
                        retVal = HTBOTTOM
                    End If
                Else
                    If IsRIGHT Then
                        retVal = HTRIGHT
                    ElseIf IsLEFT Then
                        retVal = HTLEFT
                    Else
                        'We aren't at the edge of the window, lets move it instead
                        retVal = HTCAPTION
                    End If
                End If
            End If
        Case Else
           'Other WM_xxx messages you want to intercept
           'Act as appropriate
    End Select
    
    WindowProc = retVal

End Function
